﻿using System.Threading;
using NUnit.Framework;

namespace ClipExtension.Common.Tests
{
	[TestFixture]
	public class RepositoryTest
	{
		[Test]
		public void MaxHistoryItemCountIsTwo()
		{
			var mode = new Repository { MaxHistoryItemCount = 2 };

			DataUnit first = Helper.CreateData( "first" );
			Thread.Sleep( 100 );
			DataUnit second = Helper.CreateData( "second" );
			Thread.Sleep( 100 );
			DataUnit third = Helper.CreateData( "third" );

			mode.PushToHistory( first );

			mode.PushToHistory( second );

			mode.PushToHistory( third );

			Assert.That( mode.History.Count, Is.EqualTo( 2 ) );

			Assert.That( mode.History[0], Is.EqualTo( third ) );
			Assert.That( mode.History[1], Is.EqualTo( second ) );
		}

		[Test]
		public void MaxHistoryItemCountIsZero()
		{
			var mode = new Repository { MaxHistoryItemCount = 0 };

			mode.PushToHistory( Helper.CreateData( "sample" ) );

			Assert.That( mode.History.Count, Is.EqualTo( 0 ) );
		}
	}
}