﻿namespace ClipExtension.Common.Tests
{
	public sealed class TestTextData : IData
	{
		private string TextStore;

		public string Text
		{
			get
			{
				if ( TextStore == null )
				{
					TextStore = string.Empty;
				}

				return TextStore;
			}
			set { TextStore = value; }
		}

		#region IData Members

		public IData Clone()
		{
			return new TestTextData { Text = Text };
		}

		#endregion

		public override bool Equals( object obj )
		{
			if ( ReferenceEquals( null, obj ) )
			{
				return false;
			}
			if ( ReferenceEquals( this, obj ) )
			{
				return true;
			}
			if ( obj.GetType() !=
			     typeof ( TestTextData ) )
			{
				return false;
			}

			var other = (TestTextData) obj;
			return Text.Equals( other.Text );
		}

		public override int GetHashCode()
		{
			return Text.GetHashCode();
		}

		public override string ToString()
		{
			return Text;
		}
	}
}