﻿using System.Collections.Generic;
using System.Windows.Forms;

namespace ClipExtension.Common
{
	public class DataObjectComposer
	{
		private readonly IDataObject DataObject;
		private readonly List<string> Formats = new List<string>();

		public DataObjectComposer( IDataObject iDataObject )
		{
			DataObject = iDataObject;
		}

		public bool ContainsFormat( string format )
		{
			return Formats.Contains( format );
		}

		/// <summary>
		/// 
		/// </summary>
		/// <param name="format"></param>
		/// <param name="data"></param>
		/// <param name="autoConvert"></param>
		/// <returns>Success or fail</returns>
		public bool Add( string format, object data, bool autoConvert )
		{
			if ( !ContainsFormat( format ) &&
			     data != null )
			{
				DataObject.SetData( format, autoConvert, data );
				Formats.Add( format );
				return true;
			}

			return false;
		}

		public object Compose()
		{
			return DataObject;
		}
	}
}