﻿using System.Collections.Generic;

namespace ClipExtension.Common
{
	public class DataUnitComposer
	{
		private readonly List<IData> Parts = new List<IData>();

		public void Add( IData data )
		{
			Parts.Add( data );
		}

		public DataUnit Compose()
		{
			if ( Parts.Count == 0 )
			{
				return null;
			}

			var dataUnit = new DataUnit();
			foreach ( IData part in Parts )
			{
				if ( part != null )
				{
					dataUnit.Items.Add( part );
				}
			}

			return dataUnit;
		}
	}
}