﻿using System.Collections.Generic;
using System.Linq;

namespace ClipExtension.Common
{
	public static class DataUnitsHelper
	{
		public static List<DataUnit> Clone( IEnumerable<DataUnit> dataUnits )
		{
			return dataUnits.Select( target => target.Clone() ).ToList();
		}

		public static List<DataUnit> UpdateLastUsedTimeAndClone( IEnumerable<DataUnit> dataUnits )
		{
			UpdateLastUsedTime( dataUnits );
			return dataUnits.Select( target => target.Clone() ).ToList();
		}

		public static void UpdateLastUsedTime( IEnumerable<DataUnit> dataUnits )
		{
			foreach ( DataUnit dataUnit in dataUnits )
			{
				dataUnit.UpdateLastUsedTime();
			}
		}
	}
}