﻿using System.Collections.Generic;
using System.Linq;
using ClipExtension.Plugins;

namespace ClipExtension.Main
{
	public class CommandTable<T> : ICommandTable<T>
	{
		private List<Command<T>> CommandsStore;

		public List<Command<T>> Commands
		{
			get
			{
				if ( CommandsStore == null )
				{
					CommandsStore = new List<Command<T>>();
				}

				return CommandsStore;
			}

			set { CommandsStore = value; }
		}

		#region ICommandTable<T> Members

		public bool Register( Command<T> command )
		{
			if ( Contains( command ) )
			{
				return false;
			}
			else
			{
				Commands.Add( command );
				return true;
			}
		}

		#endregion

		private bool Contains( Command<T> command )
		{
			return Commands.Any( item => command.Name == item.Name );
		}
	}
}