﻿using Tomham.IO;
using Yaowi.Common.Serialization;

namespace ClipExtension.Main
{
	public class DataUnitSerializationItemSerializer : Serializer<DataUnitSerializationItem>
	{
		private readonly XmlDeserializer Deserializer;
		private readonly XmlSerializer Serializer;

		public DataUnitSerializationItemSerializer( XmlSerializer serializer, XmlDeserializer deserializer )
		{
			Serializer = serializer;
			Deserializer = deserializer;

			ReWriteMode = ReWriteMode.NotEqual;
			ForceSerialization = true;
		}

		protected override void DoSerialize( DataUnitSerializationItem data, string fileName )
		{
			Serializer.Serialize( data, fileName );
		}

		public override DataUnitSerializationItem DeSerialize( string fileName )
		{
			return (DataUnitSerializationItem) Deserializer.Deserialize( fileName );
		}
	}
}