﻿using System.IO;
using System.Windows.Forms;
using Tomham.IO;

namespace ClipExtension.Main
{
	public class DirectoryHelper
	{
		public DirectoryHelper()
		{
			SetUpDirectories();
		}

		public string PluginsDirectory { get; set; }
		public string DataDirectory { get; set; }
		public string HistoryDirectory { get; set; }
		public string FavoritesDirectory { get; set; }

		private void SetUpDirectories()
		{
			PluginsDirectory = SetUpDirectory( "Plugins" );

			DataDirectory = SetUpDirectory( "Data" );

			HistoryDirectory = SetUpDirectory( @"Data\History" );

			FavoritesDirectory = SetUpDirectory( @"Data\Favorites" );
		}

		private string SetUpDirectory( string name )
		{
			string path = PathHelper.Combine( Application.StartupPath, name );
			Directory.CreateDirectory( path );

			return path;
		}
	}
}