﻿using System;
using System.Windows.Forms;
using Tomham.Windows.Forms;

namespace ClipExtension.Main
{
	[Serializable]
	public class Paster
	{
		private string TargetProcessNameStore;

		public Keys Keys { get; set; }

		public string TargetProcessName
		{
			get
			{
				if ( TargetProcessNameStore == null )
				{
					TargetProcessNameStore = string.Empty;
				}

				return TargetProcessNameStore;
			}
			set { TargetProcessNameStore = value; }
		}

		public void Paste()
		{
			InputKeys.Input( Keys );
		}

		public bool Equals( Paster other )
		{
			if ( ReferenceEquals( null, other ) )
			{
				return false;
			}
			if ( ReferenceEquals( this, other ) )
			{
				return true;
			}
			return Equals( other.TargetProcessName, TargetProcessName ) && Equals( other.Keys, Keys );
		}

		public override bool Equals( object obj )
		{
			if ( ReferenceEquals( null, obj ) )
			{
				return false;
			}
			if ( ReferenceEquals( this, obj ) )
			{
				return true;
			}
			if ( obj.GetType() !=
			     typeof ( Paster ) )
			{
				return false;
			}
			return Equals( (Paster) obj );
		}

		public override int GetHashCode()
		{
			unchecked
			{
				return ( TargetProcessName.GetHashCode() * 397 ) ^
				       Keys.GetHashCode();
			}
		}

		public override string ToString()
		{
			return string.Format( "{0}: {1}", TargetProcessName, Keys );
		}

		public Paster Clone()
		{
			return new Paster { TargetProcessName = TargetProcessName, Keys = Keys };
		}
	}
}