﻿using System.Collections.Generic;
using System.Diagnostics;
using System.Windows.Forms;
using Tomham.Diagnostics;

namespace ClipExtension.Main
{
	public class PasterUnit
	{
		private readonly Paster DefaultPaster = new Paster { Keys = Keys.V | Keys.Control };
		private List<Paster> PastersStore;

		public List<Paster> Pasters
		{
			get
			{
				if ( PastersStore == null )
				{
					PastersStore = new List<Paster>();
				}

				return PastersStore;
			}

			set { PastersStore = value; }
		}

		public void Paste()
		{
			Process foreground = ProcessHelper.GetForegroundWindowProcess();

			Paster paster = Find( foreground );

			paster.Paste();
		}

		private Paster Find( Process foreground )
		{
			foreach ( Paster paster in Pasters )
			{
				if ( foreground.ProcessName.ToLower().Contains( paster.TargetProcessName.ToLower() ) )
				{
					return paster;
				}
			}

			return DefaultPaster;
		}
	}
}