﻿using ClipExtension.Plugins;

namespace ClipExtension.Main
{
	public class PluginID
	{
		private string AuthorStore;
		private string NameStore;

		public string Name
		{
			get
			{
				if ( NameStore == null )
				{
					NameStore = string.Empty;
				}

				return NameStore;
			}
			set { NameStore = value; }
		}

		public string Author
		{
			get
			{
				if ( AuthorStore == null )
				{
					AuthorStore = string.Empty;
				}

				return AuthorStore;
			}
			set { AuthorStore = value; }
		}

		public bool Equals( PluginID other )
		{
			if ( ReferenceEquals( null, other ) )
			{
				return false;
			}
			if ( ReferenceEquals( this, other ) )
			{
				return true;
			}
			return Equals( other.Author, Author ) && Equals( other.Name, Name );
		}

		public override bool Equals( object obj )
		{
			if ( ReferenceEquals( null, obj ) )
			{
				return false;
			}
			if ( ReferenceEquals( this, obj ) )
			{
				return true;
			}
			if ( obj.GetType() !=
			     typeof ( PluginID ) )
			{
				return false;
			}
			return Equals( (PluginID) obj );
		}

		public override int GetHashCode()
		{
			unchecked
			{
				return ( Author.GetHashCode() * 397 ) ^ Name.GetHashCode();
			}
		}

		public override string ToString()
		{
			return Name;
		}

		public static PluginID Create( IPluginMetadata pluginMetadata )
		{
			return new PluginID { Name = pluginMetadata.Name, Author = pluginMetadata.Author };
		}
	}
}