﻿using System;
using System.Collections.Generic;
using System.Linq;
using Tomham.Collections.Generic;

namespace ClipExtension.Main
{
	[Serializable]
	public class PluginsPreference
	{
		private List<PluginID> PriorityIDsStore;

		public List<PluginID> PriorityIDs
		{
			get
			{
				if ( PriorityIDsStore == null )
				{
					PriorityIDsStore = new List<PluginID>();
				}

				return PriorityIDsStore;
			}

			set { PriorityIDsStore = value; }
		}

		public bool Equals( PluginsPreference other )
		{
			if ( ReferenceEquals( null, other ) )
			{
				return false;
			}
			if ( ReferenceEquals( this, other ) )
			{
				return true;
			}

			return PriorityIDs.SequenceEqual( other.PriorityIDs );
		}

		public override bool Equals( object obj )
		{
			if ( ReferenceEquals( null, obj ) )
			{
				return false;
			}
			if ( ReferenceEquals( this, obj ) )
			{
				return true;
			}
			if ( obj.GetType() !=
			     typeof ( PluginsPreference ) )
			{
				return false;
			}
			return Equals( (PluginsPreference) obj );
		}

		public override int GetHashCode()
		{
			return PriorityIDs.SequenceGetHashCode();
		}
	}
}