﻿using System.IO;
using System.Reflection;
using System.Xml.Serialization;
using Yaowi.Common.Serialization;
using XmlSerializer = Yaowi.Common.Serialization.XmlSerializer;

namespace ClipExtension.Main
{
	public static class SerializerHelper
	{
		public static XmlDeserializer GetXmlDeserializer( string pluginsDirectory )
		{
			var deserializer = new XmlDeserializer();

			string[] dlls =
				Directory.GetFiles( pluginsDirectory, "*.dll" );

			foreach ( string dll in dlls )
			{
				Assembly assembly = Assembly.LoadFrom( dll );

				deserializer.RegisterAssembly( assembly );
			}

			return deserializer;
		}

		public static XmlSerializer GetXmlSerializer()
		{
			var serializer = new XmlSerializer
			                 {
			                 	SerializationIgnoredAttributeType = typeof ( XmlIgnoreAttribute ),
			                 	IgnoreSerializableAttribute = true,
			                 };

			return serializer;
		}
	}
}