﻿using System;

namespace ClipExtension.Options
{
	[Serializable]
	public class AllOptions
	{
		public AllOptions()
		{
			IncrementalSearchFormOptions = new IncrementalSearchFormOptions();
			CommonOptions = new CommonOptions();
		}

		public IncrementalSearchFormOptions IncrementalSearchFormOptions { get; set; }
		public CommonOptions CommonOptions { get; set; }

		public bool Equals( AllOptions other )
		{
			if ( ReferenceEquals( null, other ) )
			{
				return false;
			}
			if ( ReferenceEquals( this, other ) )
			{
				return true;
			}
			return Equals( other.IncrementalSearchFormOptions, IncrementalSearchFormOptions ) &&
			       Equals( other.CommonOptions, CommonOptions );
		}

		public override bool Equals( object obj )
		{
			if ( ReferenceEquals( null, obj ) )
			{
				return false;
			}
			if ( ReferenceEquals( this, obj ) )
			{
				return true;
			}
			if ( obj.GetType() !=
			     typeof ( AllOptions ) )
			{
				return false;
			}
			return Equals( (AllOptions) obj );
		}

		public override int GetHashCode()
		{
			unchecked
			{
				return ( ( IncrementalSearchFormOptions != null ? IncrementalSearchFormOptions.GetHashCode() : 0 ) * 397 ) ^
				       ( CommonOptions != null ? CommonOptions.GetHashCode() : 0 );
			}
		}
	}
}