﻿using System.Collections.Generic;
using ClipExtension.Common;

namespace ClipExtension.Plugins
{
	public class EditCopyAndPasteCommand : Command<ClipboardManipulateCommandArgs>
	{
		private readonly Command<EditCommandArgs> Core;

		public EditCopyAndPasteCommand( Command<EditCommandArgs> core )
		{
			Core = core;
		}

		public override void Execute( ClipboardManipulateCommandArgs args )
		{
			if ( args.Targets.Count != 1 )
			{
				return;
			}

			List<DataUnit> clone = DataUnitsHelper.UpdateLastUsedTimeAndClone( args.Targets );

			var editArgs = new EditCommandArgs( args.Output, args.ClipboardManipulator.Repository, clone, false );

			Core.Execute( editArgs );

			args.ClipboardManipulator.CopyAndPaste( clone[0] );
		}
	}
}