﻿using ClipExtension.Common;
using Tomham;

namespace ClipExtension.Plugins
{
	public class LoadArgs : Args
	{
		public LoadArgs( IMessageOutput output,
		                 Repository repository,
		                 ICommandTable<GeneralCommandArgs> generalCommandTable,
		                 ICommandTable<ClipboardManipulateCommandArgs> clipboardManipulateCommandTable,
		                 ICommandTable<EditCommandArgs> editCommandTable )
			: base( output, repository )
		{
			EditCommandTable = editCommandTable;
			GeneralCommandTable = generalCommandTable;
			ClipboardManipulateCommandTable = clipboardManipulateCommandTable;
		}

		public ICommandTable<ClipboardManipulateCommandArgs> ClipboardManipulateCommandTable { get; set; }
		public ICommandTable<EditCommandArgs> EditCommandTable { get; set; }
		public ICommandTable<GeneralCommandArgs> GeneralCommandTable { get; set; }
	}
}