﻿using System;
using System.ComponentModel.Composition;

namespace ClipExtension.Plugins
{
	[MetadataAttribute]
	[AttributeUsage( AttributeTargets.Class, AllowMultiple = false )]
	public class PluginExportAttribute : ExportAttribute, IPluginMetadata
	{
		private string AuthorStore;
		private string DescriptionStore;
		private string NameStore;
		private string VersionStore;

		public PluginExportAttribute( Type contractType ) : base( contractType )
		{
		}

		#region IPluginMetadata Members

		public string Name
		{
			get
			{
				if ( NameStore == null )
				{
					NameStore = string.Empty;
				}

				return NameStore;
			}
			set { NameStore = value; }
		}

		public string Author
		{
			get
			{
				if ( AuthorStore == null )
				{
					AuthorStore = string.Empty;
				}

				return AuthorStore;
			}
			set { AuthorStore = value; }
		}

		public string Description
		{
			get
			{
				if ( DescriptionStore == null )
				{
					DescriptionStore = string.Empty;
				}

				return DescriptionStore;
			}
			set { DescriptionStore = value; }
		}

		public string Version
		{
			get
			{
				if ( VersionStore == null )
				{
					VersionStore = string.Empty;
				}

				return VersionStore;
			}
			set { VersionStore = value; }
		}

		#endregion
	}
}