﻿using System.Windows.Forms;
using ClipExtension.Main;
using ClipExtension.Plugins;
using Intelectix.Windows.Forms;

namespace ClipExtension
{
	public partial class PluginListForm : Form
	{
		public PluginListForm()
		{
			InitializeComponent();
		}

		public void SetUp( PluginContainer<IProcessor> processors, PluginContainer<IFormatSupporter> formatSupporters )
		{
			tabPageProcessors.Controls.Add( CreateListView( processors ) );
			tabPageFormatSupporters.Controls.Add( CreateListView( formatSupporters ) );
		}

		private ListView CreateListView<T>( PluginContainer<T> plugins )
		{
			var result = new ListView { View = View.Details, GridLines = true, Dock = DockStyle.Fill };

			result.Columns.Add( "名前", 200 );
			result.Columns.Add( "説明", 600 );
			result.Columns.Add( "作者" );
			result.Columns.Add( "バージョン" );

			foreach ( var plugin in plugins.Items )
			{
				var item = new ListViewItem( plugin.Metadata.Name );
				item.SubItems.Add( plugin.Metadata.Description );
				item.SubItems.Add( plugin.Metadata.Author );
				item.SubItems.Add( plugin.Metadata.Version );

				result.Items.Add( item );
			}

			var sortManager = new ListViewSortManager(
				result,
				new[]
				{
					typeof ( ListViewTextSort ),
					typeof ( ListViewTextSort ),
					typeof ( ListViewTextSort ),
					typeof ( ListViewTextSort )
				} );
			return result;
		}
	}
}