﻿using System.Collections.Generic;
using System.Linq;

namespace Tomham.Collections.Generic
{
	public class EnumerableEqualityComparer<T> : EqualityComparer<IEnumerable<T>>
	{
		public override bool Equals( IEnumerable<T> x, IEnumerable<T> y )
		{
			if ( ReferenceEquals( x, y ) )
			{
				return true;
			}

			if ( x == null )
			{
				if ( y == null )
				{
					return true;
				}
				else
				{
					return false;
				}
			}
			else
			{
				if ( y == null )
				{
					return false;
				}
				else
				{
					return x.SequenceEqual( y );
				}
			}
		}

		public override int GetHashCode( IEnumerable<T> obj )
		{
			if ( obj == null )
			{
				return 0;
			}

			return obj.SequenceGetHashCode();
		}
	}
}