using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using Tomham.Diagnostics;
using NUnit.Framework;

namespace Tomham.DiagnosticsTest
{
	[TestFixture]
	public class UtilityTest
	{
		[Test]
		public void CreateProcessStartInfo1()
		{
			Console.WriteLine( "CreateProcessStartInfo1" );

			string commandLine = "\"test app.exe\" -arg";

			ProcessStartInfo info = Utility.CreateProcessStartInfo( commandLine );

			Console.WriteLine( "info.FileName is: " + info.FileName );
			Console.WriteLine( "info.Arguments is: " + info.Arguments );

			Assert.AreEqual( info.FileName, "test app.exe" );

			Assert.AreEqual( info.Arguments, "-arg" );
		}

		[Test]
		public void CreateProcessStartInfo2()
		{
			Console.WriteLine( "CreateProcessStartInfo2" );

			string commandLine = "test.txt -arg";

			ProcessStartInfo info = Utility.CreateProcessStartInfo( commandLine );

			Console.WriteLine( "info.FileName is: " + info.FileName );
			Console.WriteLine( "info.Arguments is: " + info.Arguments );

			Assert.AreEqual( info.FileName, "test.txt" );

			Assert.AreEqual( info.Arguments, "-arg" );		
		}

		[Test]
		public void CreateProcessStartInfo3()
		{
			Console.WriteLine( "CreateProcessStartInfoNoArgs" );

			string commandLine = "test.txt";

			ProcessStartInfo info = Utility.CreateProcessStartInfo( commandLine );

			Console.WriteLine( "info.FileName is: " + info.FileName );
			Console.WriteLine( "info.Arguments is: " + info.Arguments );

			Assert.AreEqual( info.FileName, "test.txt" );

			Assert.AreEqual( info.Arguments, string.Empty );
			
		}

	}

}
