﻿using NUnit.Framework;

namespace Tomham.IO.FileManipulation.Tests
{
	[TestFixture]
	public class AndConditionTest
	{
		#region Setup/Teardown

		[SetUp]
		public void SetUp()
		{
			TestHelper.SetUp();
		}

		#endregion

		[Test]
		public void ConditionAllFalse()
		{
			AndCondition andCondition = new AndCondition();

			andCondition.Add( new FalseCondition() );
			andCondition.Add( new FalseCondition() );

			Assert.IsFalse( andCondition.IsMatch( TestHelper.GetArguments() ) );
		}

		[Test]
		public void ConditionAllTrue()
		{
			AndCondition andCondition = new AndCondition();

			andCondition.Add( new TrueCondition() );
			andCondition.Add( new TrueCondition() );

			Assert.IsTrue( andCondition.IsMatch( TestHelper.GetArguments() ) );
		}

		[Test]
		public void ConditionCountIsZero()
		{
			AndCondition andCondition = new AndCondition();

			Assert.AreEqual( 0, andCondition.Count );
			Assert.IsFalse( andCondition.IsMatch( TestHelper.GetArguments() ) );
		}

		[Test]
		public void ConditionTrueAndFalse()
		{
			AndCondition andCondition = new AndCondition();

			andCondition.Add( new TrueCondition() );
			andCondition.Add( new FalseCondition() );

			Assert.IsFalse( andCondition.IsMatch( TestHelper.GetArguments() ) );
		}
	}
}