﻿using System.Collections.Generic;
using System.Collections.ObjectModel;

namespace Tomham.IO
{
	public class EditableItemInformationCollection<T> : Collection<EditableItemInformation<T>>
	{
		public EditableItemInformation<T>[] GetModifiedItems()
		{
			List<EditableItemInformation<T>> list = new List<EditableItemInformation<T>>();

			foreach ( EditableItemInformation<T> information in Items )
			{
				if ( information.Modified )
				{
					list.Add( information );
				}
			}

			return list.ToArray();
		}

		public T[] GetItems()
		{
			List<T> list = new List<T>();

			foreach ( EditableItemInformation<T> information in Items )
			{
				list.Add( information.Item );
			}

			return list.ToArray();
		}

		public string[] GetFileNames()
		{
			List<string> list = new List<string>();

			foreach ( EditableItemInformation<T> information in Items )
			{
				list.Add( information.FileName );
			}

			return list.ToArray();
		}
	}
}