﻿using System;

namespace Tomham.IO.FileManipulation
{
	[Serializable]
	public class OrCondition : ComplexCondition
	{
		public override bool IsMatch( MatchArguments arguments )
		{
			foreach ( ICondition condition in this )
			{
				if ( condition.IsMatch( arguments ) )
				{
					return true;
				}
			}

			return false;
		}

		public override ICondition Clone()
		{
			ComplexCondition clone = new OrCondition();

			foreach ( ICondition condition in this )
			{
				clone.Add( condition.Clone() );
			}

			return clone;
		}
	}
}