using System.IO;

namespace Tomham.IO.FileManipulation
{
	public abstract class TextCondition : ICondition
	{
		private string PatternStore;

		protected TextCondition()
		{
			IgnoreCase = true;
			OnlyNameMatching = true;
		}

		public string Pattern
		{
			get
			{
				if ( PatternStore == null )
				{
					PatternStore = string.Empty;
				}

				return PatternStore;
			}
			set { PatternStore = value; }
		}

		public bool IgnoreCase { get; set; }
		public bool OnlyNameMatching { get; set; }

		#region ICondition Members

		public bool IsMatch( MatchArguments arguments )
		{
			string target;

			if ( OnlyNameMatching )
			{
				target = PathHelper.GetName( arguments.Source );
			}
			else
			{
				target = Path.GetFullPath( arguments.Source );
			}

			return IsMatch( target );
		}

		public abstract ICondition Clone();

		#endregion

		protected abstract bool IsMatch( string target );
	}
}