﻿using System.Windows.Forms;
using NUnit.Framework;

namespace Tomham.Windows.Forms.Tests
{
	[TestFixture]
	public class HotKeyTest
	{
		[Test]
		public void Create()
		{
			var hotKey = new HotKey();
			Assert.That( hotKey.CombinationKeys, Is.EqualTo( new CombinationKeys() ) );
			Assert.That( hotKey.HasRegistered, Is.EqualTo( false ) );
		}

		[Test]
		public void SetInValidKeys()
		{
			var hotKey = new HotKey();
			var keys = new CombinationKeys { Modifiers = Modifiers.Alt };
			hotKey.CombinationKeys = keys;

			Assert.That( hotKey.CombinationKeys.KeyCode, Is.EqualTo( Keys.None ) );
			Assert.That( hotKey.CombinationKeys.Modifiers, Is.EqualTo( Modifiers.None ) );
			Assert.That( hotKey.HasRegistered, Is.EqualTo( false ) );
		}
	}
}