﻿using System;

namespace Tomham.Windows.Forms.AutoGeneration
{
	public abstract class ControllerFactory
	{
		public abstract bool IsTarget( object target );
		protected abstract Controller DoCreate( object target );

		public Controller Create( object target )
		{
			if ( IsTarget( target ) )
			{
				return DoCreate( target );
			}

			throw new InvalidOperationException( "target is not supported." );
		}
	}
}