﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Windows.Forms;

namespace Tomham.Windows.Forms
{
	public partial class SelectForm : Form
	{
		public SelectForm()
		{
			InitializeComponent();
		}

		[Browsable( false )]
		[DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
		public List<object> SelectedItems { get; private set; }

		[Browsable( false )]
		[DesignerSerializationVisibility( DesignerSerializationVisibility.Hidden )]
		public object SelectedItem
		{
			get
			{
				List<object> selectedItems = SelectedItems;
				if ( selectedItems == null )
				{
					return null;
				}

				if ( 0 < selectedItems.Count )
				{
					return selectedItems[0];
				}
				else
				{
					return null;
				}
			}
		}

		[Category( "Behavior" )]
		[Browsable( true )]
		public SelectionMode SelectionMode
		{
			get { return ContentsFilterListBox.SelectionMode; }
			set { ContentsFilterListBox.SelectionMode = value; }
		}

		public void SetSource( IEnumerable source )
		{
			ContentsFilterListBox.SetSource( source );
		}

		private void TrySetSelectedItemsAndReturnOK()
		{
			if ( ContentsFilterListBox.HasSelectedItems() )
			{
				SelectedItems = ContentsFilterListBox.GetSelectedItems<object>();
				DialogResult = DialogResult.OK;
			}
		}

		private void TryOK( object sender, EventArgs e )
		{
			TrySetSelectedItemsAndReturnOK();
		}

		private void ContentsFilterListBox_ComboBoxOrListBoxKeyDown( object sender, KeyEventArgs e )
		{
			if ( e.KeyData ==
			     Keys.Return )
			{
				e.SuppressKeyPress = true;
				TrySetSelectedItemsAndReturnOK();
			}
		}
	}
}