﻿using System;
using System.ComponentModel;
using System.Windows.Forms;

namespace Tomham.Windows.Forms
{
	public partial class UpDownListBox : UserControl
	{
		public UpDownListBox()
		{
			InitializeComponent();
		}

		[Category( "Default" )]
		[BrowsableAttribute( true )]
		[DesignerSerializationVisibility( DesignerSerializationVisibility.Content )]
		public ListBox ListBox
		{
			get { return ContentsListBox; }
		}

		[Category( "Appearance" )]
		[Browsable( true )]
		public string UpButtonText
		{
			get { return UpButton.Text; }
			set { UpButton.Text = value; }
		}

		[Category( "Appearance" )]
		[Browsable( true )]
		public string DownButtonText
		{
			get { return DownButton.Text; }
			set { DownButton.Text = value; }
		}

		private void UpButton_Click( object sender, EventArgs e )
		{
			ContentsListBox.MoveUpSelectedItems();
		}

		private void DownButton_Click( object sender, EventArgs e )
		{
			ContentsListBox.MoveDownSelectedItems();
		}
	}
}