﻿namespace Tomham.Windows.Forms
{
	public static class VirtualKey
	{
		public const byte CANCEL = 0x03;
		public const byte BACK = 0x08;
		public const byte TAB = 0x09;
		public const byte CLEAR = 0x0c;
		public const byte RETURN = 0x0d;

		public const byte SHIFT = 0x10;
		public const byte CONTROL = 0x11;
		// Alt
		public const byte MENU = 0x12;

		public const byte PAUSE = 0x13;
		public const byte CAPITAL = 0x14;
		public const byte KANA = 0x15;
		public const byte JUNJA = 0x17;
		public const byte FINAL = 0x18;
		public const byte KANJI = 0x19;
		public const byte ESCAPE = 0x1b;
		public const byte CONVERT = 0x1c;
		public const byte NONCONVERT = 0x1d;
		public const byte ACCEPT = 0x1e;
		public const byte MODECHANGE = 0x1f;
		public const byte SPACE = 0x20;
		public const byte PRIOR = 0x21;
		public const byte NEXT = 0x22;
		public const byte END = 0x23;
		public const byte HOME = 0x24;
		public const byte LEFT = 0x25;
		public const byte UP = 0x26;
		public const byte RIGHT = 0x27;
		public const byte DOWN = 0x28;
		public const byte SELECT = 0x29;
		public const byte PRINT = 0x2a;
		public const byte EXECUTE = 0x2b;
		public const byte SNAPSHOT = 0x2c;
		public const byte INSERT = 0x2d;
		public const byte DELETE = 0x2e;
		public const byte HELP = 0x2f;

		// Keysに合わせて数字キーにはDを付ける
		public const byte D0 = 0x30;
		public const byte D1 = 0x31;
		public const byte D2 = 0x32;
		public const byte D3 = 0x33;
		public const byte D4 = 0x34;
		public const byte D5 = 0x35;
		public const byte D6 = 0x36;
		public const byte D7 = 0x37;
		public const byte D8 = 0x38;
		public const byte D9 = 0x39;

		public const byte A = 0x41;
		public const byte B = 0x42;
		public const byte C = 0x43;
		public const byte D = 0x44;
		public const byte E = 0x45;
		public const byte F = 0x46;
		public const byte G = 0x47;
		public const byte H = 0x48;
		public const byte I = 0x49;
		public const byte J = 0x4a;
		public const byte K = 0x4b;
		public const byte L = 0x4c;
		public const byte M = 0x4d;
		public const byte N = 0x4e;
		public const byte O = 0x4f;
		public const byte P = 0x50;
		public const byte Q = 0x51;
		public const byte R = 0x52;
		public const byte S = 0x53;
		public const byte T = 0x54;
		public const byte U = 0x55;
		public const byte V = 0x56;
		public const byte W = 0x57;
		public const byte X = 0x58;
		public const byte Y = 0x59;
		public const byte Z = 0x5a;

		public const byte LWIN = 0x5b;
		public const byte RWIN = 0x5c;
		public const byte APPS = 0x5d;

		public const byte NUMPAD0 = 0x60;
		public const byte NUMPAD1 = 0x61;
		public const byte NUMPAD2 = 0x62;
		public const byte NUMPAD3 = 0x63;
		public const byte NUMPAD4 = 0x64;
		public const byte NUMPAD5 = 0x65;
		public const byte NUMPAD6 = 0x66;
		public const byte NUMPAD7 = 0x67;
		public const byte NUMPAD8 = 0x68;
		public const byte NUMPAD9 = 0x69;
		public const byte MULTIPLY = 0x6a;
		public const byte ADD = 0x6b;
		public const byte SEPERATOR = 0x6c;
		public const byte SUBTRACT = 0x6d;
		public const byte DECIMAL = 0x6e;
		public const byte DEVIDE = 0x6f;

		public const byte F1 = 0x70;
		public const byte F2 = 0x71;
		public const byte F3 = 0x72;
		public const byte F4 = 0x73;
		public const byte F5 = 0x74;
		public const byte F6 = 0x75;
		public const byte F7 = 0x76;
		public const byte F8 = 0x77;
		public const byte F9 = 0x78;
		public const byte F10 = 0x79;
		public const byte F11 = 0x7a;
		public const byte F12 = 0x7b;
		public const byte F13 = 0x7c;
		public const byte F14 = 0x7d;
		public const byte F15 = 0x7e;
		public const byte F16 = 0x7f;
		public const byte F17 = 0x80;
		public const byte F18 = 0x81;
		public const byte F19 = 0x82;
		public const byte F20 = 0x83;
		public const byte F21 = 0x84;
		public const byte F22 = 0x85;
		public const byte F23 = 0x86;
		public const byte F24 = 0x87;

		public const byte NUMLOCK = 0x90;
		public const byte SCROLL = 0x91;
		public const byte LSHIFT = 0xa0;
		public const byte RSHIFT = 0xa1;
		public const byte LCONTROL = 0xa2;
		public const byte RCONTROL = 0xa3;
		public const byte LMENU = 0xa4;
		public const byte RMENU = 0xa5;
		public const byte BROWSER_BACK = 0xa6;
		public const byte BROWSER_FORWARD = 0xa7;
		public const byte BROWSER_REFRESH = 0xa8;
		public const byte BROWSER_STOP = 0xa9;
		public const byte BROWSER_SEARCH = 0xaa;
		public const byte BROWSER_FAVORITES = 0xab;
		public const byte BROWSER_HOME = 0xa6;
		public const byte VOLUME_MUTE = 0xad;
		public const byte VOLUME_DOWN = 0xae;
		public const byte VOLUME_UP = 0xaf;
		public const byte MEDIA_NEXT_TRACK = 0xb0;
		public const byte MEDIA_PREV_TRACK = 0xb1;
		public const byte MEDIA_STOP = 0xb2;
		public const byte MEDIA_PLAY_PAUSE = 0xb3;
		public const byte LAUNCH_MAIL = 0xb4;
		public const byte LAUNCH_MEDIA_SELECT = 0xb5;
		public const byte LAUNCH_APP1 = 0xb6;
		public const byte LAUNCH_APP2 = 0xb7;
		public const byte OEM_1 = 0xba;
		public const byte OEM_PLUS = 0xbb;
		public const byte OEM_COMMA = 0xbc;
		public const byte OEM_MINUS = 0xbd;
		public const byte OEM_PERIOD = 0xbe;
		public const byte OEM_2 = 0xbf;
		public const byte OEM_3 = 0xc0;
		public const byte OEM_4 = 0xdb;
		public const byte OEM_5 = 0xdc;
		public const byte OEM_6 = 0xdd;
		public const byte OEM_7 = 0xde;
		public const byte OEM_8 = 0xdf;
		public const byte PROCESS = 0xe5;
		public const byte OEM_ATTN = 0xf0;
		public const byte OEM_102 = 0xe2;
		public const byte OEM_COPY = 0xf2;
		public const byte OEM_AUTO = 0xf3;
		public const byte OEM_ENLW = 0xf4;
		public const byte OEM_BACKTAB = 0xf5;
		public const byte PACKET = 0xe7;
		public const byte ATTN = 0xf6;
		public const byte CRSEL = 0xf7;
		public const byte EXSEL = 0xf8;
		public const byte EREOF = 0xf9;
		public const byte PLAY = 0xfa;
		public const byte ZOOM = 0xfb;
		public const byte NONAME = 0xfc;
		public const byte PA1 = 0xfd;
		public const byte OEM_CLEAR = 0xfe;
	}
}