﻿using System.Collections.Generic;

namespace Tomham
{
	/// <summary>
	/// 
	/// </summary>
	/// <remarks>Thread safe.</remarks>
	public class MessageBoard
	{
		private readonly List<string> Messages = new List<string>();

		public string[] GetAndClearMessages()
		{
			lock ( Messages )
			{
				string[] result = GetMessages();

				Messages.Clear();

				return result;
			}
		}

		public string[] GetMessages()
		{
			lock ( Messages )
			{
				return Messages.ToArray();
			}
		}

		public void ClearMessages()
		{
			lock ( Messages )
			{
				Messages.Clear();
			}
		}

		public void AddMessages( params string[] messages )
		{
			lock ( Messages )
			{
				Messages.AddRange( messages );
			}
		}
	}
}