using System;
using System.Collections.Generic;
using System.Text;

namespace Tomham
{
	public abstract class TemplateBasedFactory<TProduct, TKey, TTemplate>
	{
		private Dictionary<TKey, TTemplate> templates =
			new Dictionary<TKey, TTemplate>();

		public Dictionary<TKey, TTemplate> Templates
		{
			get
			{
				return templates;
			}
			set
			{
				templates = value;
			}
		}

		public TProduct Create( TKey key )
		{
			TTemplate template = this.templates[key];

			return Create( template );
		}

		protected abstract TProduct Create( TTemplate template );

		public void Add( TKey key, TTemplate template )
		{
			this.templates.Add( key, template );
		}
	}
}
